#include <stdio.h>
#include <stdlib.h>

#define TEST_VECTOR_SIZE 1024
#define quit(msg) {printf(msg "\n");return(1);}

void addvector(int* src_vector1, int* src_vector2, int* dst_vector, int vector_size)
{
	for (int i = 0;i < vector_size;i++)
	{
		dst_vector[i] = src_vector1[i] + src_vector2[i];
	}
}

int main(int argc, char** argv)
{
	//Allocate host for three vectors
	int *host_vector[3];			//vector[0] and vector[1] are the source for the addition, result stored in vector[2]
	for (int i = 0;i < 3;i++)
	{
		if ((host_vector[i] = new int[TEST_VECTOR_SIZE]) == NULL) quit("Memory allocation error");
	}

	//Initialize vectors
	for (int i = 0;i < TEST_VECTOR_SIZE;i++)
	{
		host_vector[0][i] = host_vector[1][i] = i;
		host_vector[2][i] = 0;
	}

	addvector(host_vector[0], host_vector[1], host_vector[2], TEST_VECTOR_SIZE);

	//Display result
	printf("Result: ");
	for (int i = 0;i < TEST_VECTOR_SIZE;i++)
	{
		if (i == 64) break;
		printf("%d ", host_vector[2][i]);
	}
	printf("\n");

	//Clean Up
	for (int i = 0;i < 3;i++)
	{
		delete[] host_vector[i];
	}

	//Exit
	return 0;
}

